<template>
  <button
      :disabled="disabled || inProgress"
      :class="[$attrs.class, `button${colorClassSuffix}`]"
      @click="$emit('click')"
  >
    <div v-if="inProgress" :class="`loader${colorClassSuffix}`">loading...</div>
    <slot v-else/>
  </button>
</template>

<script>
  import { ButtonType } from './ButtonType'

  export default {
    name: 'VButton',
    props: {
      type: { type: String, default: ButtonType.INFO },
      inProgress: Boolean,
      disabled: Boolean
    },
    computed: {
      colorClassSuffix() { switch (this.type) {
        case ButtonType.INFO: return '-info'
        case ButtonType.SUCCESS: return '-success'
        case ButtonType.DANGER: return '-danger'
        default: return ""
      }}
    }
  }
</script>

<style scoped lang="scss">
  @import "../color";
  @import "./spinner";
  @import "./dark/v-button";

  button {
    position: relative;
    width: 16em;
    height: 2.25em;
    border-radius: 0.5em;
    margin: 1.25em 1.25em 1.4em;
    font-size: 1em;
    color: white;
    font-weight: 500;
    cursor: pointer;
    border: none;
    background-color: #E6E6E6;

    &:focus {
      outline: none;
    }
    &:disabled {
      cursor: default;
    }
  }

  .button-info {
    background-color: $color-info;

    &:focus {
      box-shadow: 0 0 0 0.05em #6699B7;
    }
    &:hover {
      background-color: #24d2ec;
    }
    &:disabled {
      background-color: $color-info-light;
    }
  }

  .button-success {
    background-color: $color-success;

    &:focus {
      box-shadow: 0 0 0 0.05em #379385;
    }
    &:hover {
      background-color: #00e4d7;
    }
    &:disabled {
      background-color: $color-success-light;
    }
  }

  .button-danger {
    background: $color-danger;

    &:focus {
      box-shadow: 0 0 0 0.05em #8B3429;
    }
    &:hover {
      background-color: #d36b5e;
    }
    &:disabled {
      background-color: $color-danger-light;
    }
  }
</style>